#include<fstream>
#include<string>
#include<iostream>
using namespace std;
ifstream fi("STRD4.inp");
ofstream fo("STRD4.out");
string s;
int l=0;
int c,d;
int main()
{
	getline(fi,s);
	for(int i=0;i<s.length();i++)
	{
		c=int(s[i])-48;
		if(i!=s.length()-1)
		{
			d=int(s[i+1])-48;
			if((c*10+d)%4==0)
			{
				l+=i+1;
			}
		}	
		if(c%4==0) l++;
	}
	fo<<l;
	fi.close();
	fo.close();
}
